from .ftdi import Ftdi as Ftdi, FtdiError as FtdiError
from _typeshed import Incomplete
from typing import Any, Iterable, Mapping, Optional, Set, Union
from usb.core import Device as UsbDevice

class SpiIOError(FtdiError): ...

class SpiPort:
    log: Incomplete
    def __init__(
        self,
        controller: SpiController,
        cs: int,
        cs_hold: int = ...,
        spi_mode: int = ...,
    ) -> None: ...
    def exchange(
        self,
        out: Union[bytes, bytearray, Iterable[int]] = ...,
        readlen: int = ...,
        start: bool = ...,
        stop: bool = ...,
        duplex: bool = ...,
        droptail: int = ...,
    ) -> bytes: ...
    def read(
        self,
        readlen: int = ...,
        start: bool = ...,
        stop: bool = ...,
        droptail: int = ...,
    ) -> bytes: ...
    def write(
        self,
        out: Union[bytes, bytearray, Iterable[int]],
        start: bool = ...,
        stop: bool = ...,
        droptail: int = ...,
    ) -> None: ...
    def flush(self) -> None: ...
    def set_frequency(self, frequency: float): ...
    def set_mode(self, mode: int, cs_hold: Optional[int] = ...) -> None: ...
    def force_select(
        self, level: Optional[bool] = ..., cs_hold: float = ...
    ) -> None: ...
    @property
    def frequency(self) -> float: ...
    @property
    def cs(self) -> int: ...
    @property
    def mode(self) -> int: ...

class SpiGpioPort:
    log: Incomplete
    def __init__(self, controller: SpiController) -> None: ...
    @property
    def pins(self) -> int: ...
    @property
    def all_pins(self) -> int: ...
    @property
    def width(self) -> int: ...
    @property
    def direction(self) -> int: ...
    def read(self, with_output: bool = ...) -> int: ...
    def write(self, value: int) -> None: ...
    def set_direction(self, pins: int, direction: int) -> None: ...

class SpiController:
    SCK_BIT: int
    DO_BIT: int
    DI_BIT: int
    CS_BIT: int
    SPI_BITS: Incomplete
    PAYLOAD_MAX_LENGTH: int
    log: Incomplete
    def __init__(self, cs_count: int = ..., turbo: bool = ...) -> None: ...
    def configure(
        self, url: Union[str, UsbDevice], **kwargs: Mapping[str, Any]
    ) -> None: ...
    def close(self, freeze: bool = ...) -> None: ...
    def terminate(self) -> None: ...
    def get_port(
        self, cs: int, freq: Optional[float] = ..., mode: int = ...
    ) -> SpiPort: ...
    def get_gpio(self) -> SpiGpioPort: ...
    @property
    def ftdi(self) -> Ftdi: ...
    @property
    def configured(self) -> bool: ...
    @property
    def frequency_max(self) -> float: ...
    @property
    def frequency(self) -> float: ...
    @property
    def direction(self): ...
    @property
    def channels(self) -> int: ...
    @property
    def active_channels(self) -> Set[int]: ...
    @property
    def gpio_pins(self): ...
    @property
    def gpio_all_pins(self): ...
    @property
    def width(self): ...
    @property
    def is_inverted_cpha_supported(self) -> bool: ...
    def exchange(
        self,
        frequency: float,
        out: Union[bytes, bytearray, Iterable[int]],
        readlen: int,
        cs_prolog: Optional[bytes] = ...,
        cs_epilog: Optional[bytes] = ...,
        cpol: bool = ...,
        cpha: bool = ...,
        duplex: bool = ...,
        droptail: int = ...,
    ) -> bytes: ...
    def force_control(self, frequency: float, sequence: bytes) -> None: ...
    def flush(self) -> None: ...
    def read_gpio(self, with_output: bool = ...) -> int: ...
    def write_gpio(self, value: int) -> None: ...
    def set_gpio_direction(self, pins: int, direction: int) -> None: ...
